#include <stdio.h>

struct RECORD
{
	float temperatura;
	float umidita;
	float pressione;
};

int giorniTrascorsi(unsigned int giorno, unsigned int mese, unsigned int anno)
{
	unsigned int giorni[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	int m, gg = 0;
	
	if (giorno < 1 || giorno > 31)
      return -1;
	if (mese < 1 || mese > 12)	  
	  return -1;
	for (m=0; m<(mese-1); m++)
	   gg += giorni[m];
	gg += giorno;
	if (anno%4 == 0)
	  if (mese > 2)
	    gg++;
    return gg;
}

struct DATAORA
{
	unsigned int giorno;
	unsigned int mese;
	unsigned int anno;
	unsigned int ora;
	unsigned int minuti;
	unsigned int secondi;
};

int getMeteoData(struct DATAORA dataora, struct RECORD *record)
{
	FILE* file;
	long offset = (giorniTrascorsi(dataora.giorno, dataora.mese, dataora.anno) - 1)*24*60 + dataora.ora*60 + dataora.minuti;
	
	file = fopen("meteodata.bin", "rb");
	if (file == NULL)
	  return -1;
	if (fseek(file, offset, SEEK_SET) != 0)
	  {
	   fclose(file);
	   return -1;
      }
	if (fread(record, sizeof(struct RECORD), 1, file) != 1)
	  {
	   fclose(file);
	   return -1;
      }
	fclose(file);
	return 0;
}

