
#include <stdio.h>

struct POSIZIONE
{
 unsigned char giorno;
 unsigned char mese;
 unsigned short anno;
 unsigned char ora;
 unsigned char minuti;
 unsigned char secondi;
 signed char gradi_latitudine;
 unsigned char primi_latitudine;
 unsigned char secondi_latitudine;
 signed short gradi_longitudine;
 unsigned char primi_longitudine;
 unsigned char secondi_longitudine;
};


int main(int argc, char* argv[])
{
 FILE *sorgente, *destinazione;
 struct POSIZIONE posizione;


 if (argc != 3)
   {
	printf("Errore: fornire i nomi dei file sorgente e destinazione come argomenti!\r\n");
	return 0;
   }

 // apertura file
 sorgente = fopen(argv[1], "rb");
 if (sorgente == NULL)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[1]);
	return 0;
   }
 destinazione = fopen(argv[2], "wt");
 if (destinazione == NULL)
   {
	printf("Errore apertura file sorgente \"%s\"\r\n", argv[2]);
	fclose(sorgente);
	return 0;
   }

 while (!feof(sorgente))
      {
	   // lettura record da file binario
	   if (fread(&posizione, sizeof(posizione), 1, sorgente) < 1)
	     break;
	   // scrittura campi nel file testuale
	   fprintf(destinazione, "%02u:%02u:%02u,", posizione.ora, posizione.minuti, posizione.secondi);
	   fprintf(destinazione, "%02u/%02u/%03u,", posizione.giorno, posizione.mese, posizione.anno);
	   if (posizione.gradi_latitudine >= 0)
	     fprintf(destinazione, "%02u%02u'%02u\"N,", posizione.gradi_latitudine, posizione.primi_latitudine, posizione.secondi_latitudine);
	   else
           fprintf(destinazione, "%02u%02u'%02u\"S,", -posizione.gradi_latitudine, posizione.primi_latitudine, posizione.secondi_latitudine);
       if (posizione.gradi_longitudine >= 0)
	     fprintf(destinazione, "%03u%02u'%02u\"E\r\n", posizione.gradi_longitudine, posizione.primi_longitudine, posizione.secondi_longitudine);
	   else
           fprintf(destinazione, "%03u%02u'%02u\"W\r\n", -posizione.gradi_longitudine, posizione.primi_longitudine, posizione.secondi_longitudine);
      }
 // chiusura file
 fclose(sorgente);
 fclose(destinazione);
 return 1;
}
